/*
 * @Author: mojunshou 1637302775@qq.com
 * @Date: 2025-03-20 15:40:20
 * @LastEditors: mojunshou 1637302775@qq.com
 * @LastEditTime: 2025-03-25 15:18:55
 * @Description:设置界面 
 */
import { _decorator } from "cc";
import { oops } from "db://oops-framework/core/Oops";
import { ecs } from "db://oops-framework/libs/ecs/ECS";
import { CCComp } from "db://oops-framework/module/common/CCComp";
import { UIID } from "../config/GameUIConfig";
import { CCVMParentComp } from "db://oops-framework/module/common/CCVMParentComp";
import { Toggle } from "cc";

const { ccclass, property } = _decorator;

/** 视图层对象 */
@ccclass('SettingViewComp')
@ecs.register('SettingView', false)
export class SettingViewComp extends CCVMParentComp {
    data: any = {
        nickName: "金砖大王",
        uid: "1234567890",
        music_state: true,
        effect_state: true
    }
    /** 视图层逻辑代码分离演示 */
    start() {
        // const entity = this.ent as ecs.Entity;         // ecs.Entity 可转为当前模块的具体实体对象
        this.setButton();
    }

    /** 视图对象通过 ecs.Entity.remove(SettingViewComp) 删除组件是触发组件处理自定义释放逻辑 */
    reset() {
        this.node.destroy();
    }


    private btn_about() {
        oops.gui.open(UIID.AboutUs);
    }


    private btn_close() {
        oops.gui.remove(UIID.Setting);
    }


    private btn_cache() {
        oops.gui.toast("清理成功");
    }



    /**
     * @description: 设置音乐开关
     * @param {Toggle} toggle
     * @return {*}
     */
    private onMusicToggleContainerClick(toggle: Toggle) {
        switch (toggle.node.name) {
            case "On":
                this.data.music_state = true;
                break;
            case "Off":
                this.data.music_state = false;
                break;
        }
        console.log("音乐状态", this.data.music_state);
        oops.audio.switchMusic = this.data.music_state;
    }

    /**
     * @description: 设置音乐开关
     * @param {Toggle} toggle
     * @return {*}
     */
    private onEffectToggleContainerClick(toggle: Toggle) {
        switch (toggle.node.name) {
            case "On":
                this.data.effect_state = true;
                break;
            case "Off":
                this.data.effect_state = false;
                break;
        }
        console.log("音效状态", this.data.effect_state);
        oops.audio.switchEffect = this.data.effect_state;
    }




}